package misc

import (
	"encoding/json"
	"skunkyart/util"
	"strconv"
)

func DD(page int, out chan string) {
	{
		var (
			j struct {
				Deviations []util.Deviation
			}
			tmp struct {
				D, P string
			}
		)

		if page == 0 {
			page++
		}

		rawjson := util.Puppy("dabrowse/networkbar/rfy/deviations?page=" + strconv.Itoa(page))
		json.Unmarshal([]byte(rawjson), &j)

		for _, a := range j.Deviations {
			tmp.D += util.Images(a, a.Media, false)
		}

		if page > 1 {
			tmp.P += "<a href=\"" + util.Conf.Base_uri + "dd?p=" + strconv.Itoa(int(page)-1) + "\"><-- Back</a> "
		}
		tmp.P += "<a href=\"" + util.Conf.Base_uri + "dd?p=" + strconv.Itoa(int(page)+1) + "\">Next --></a>"

		out <- util.TmpExec("templates/dd.htm", &tmp)
	}
}
