package util

import (
	"bytes"
	"io"
	"net/http"
	"strings"
	"text/template"

	"golang.org/x/net/html"
)

func Request(url string, cookie string) (string, int, []*http.Cookie, http.Header) {
	// println(url)
	cli := &http.Client{}
	request, err := http.NewRequest("GET", url, nil)
	request.Header.Set("User-Agent", "Mozilla/5.0 (X11; Linux x86_64; rv:123.0) Gecko/20100101 Firefox/123.0.0")
	request.Header.Set("Cookie", cookie)
	Err(err)
	response, err := cli.Do(request)
	Err(err)
	body, err := io.ReadAll(response.Body)
	Err(err)
	response.Body.Close()
	return string(body), response.StatusCode, response.Cookies(), response.Header
}

func TmpExec(file string, templatee any) string {
	var buf bytes.Buffer
	tmpl, err := template.ParseFiles(file)
	Err(err)

	tmpl.Execute(&buf, &templatee)
	return strings.ReplaceAll(buf.String(), "!BAZE!", "<base href=\""+Conf.Base_uri+"\">")
}

func Render(n *html.Node) string {
	var buffer bytes.Buffer
	html.Render(io.Writer(&buffer), n)
	return buffer.String()
}

func Err(err error) {
	if err != nil {
		println(err.Error())
	}
}
