package util

import (
	"fmt"
	"net/http"
	"strconv"
	"strings"
)

var cookie []*http.Cookie
var zond, token string

func CSRFToken() {
	// получаем отслеживающий куки, без которого не удастся получить жсон в будущем
	if cookie == nil || zond == "" {
		_, _, _c, _ := Request("https://www.deviantart.com/_puppy/", "")
		cookie = _c

		for _, a := range cookie {
			zond = a.Raw
		}
	}

	body, status, _, _ := Request("https://www.deviantart.com/", zond)
	if status != 200 {
		token = "Something went wrong. Status: " + strconv.Itoa(status)
	}
	token = body[strings.Index(body, "window.__CSRF_TOKEN__ = '")+25 : strings.Index(body, "window.__XHR_LOCAL__")-3]
}

func Puppy(data string) string {
	// получаем жсон
	if zond != "" {
		if token[0:21] == "Something went wrong." {
			return token
		}

		jsonbody, status, _, _ := Request(fmt.Sprintf("https://www.deviantart.com/_puppy/%s&csrf_token=%s&da_minor_version=20230710", data, token), zond)
		if status == 400 && jsonbody == `{"error":"invalid_request","errorDescription":"Invalid or expired form submission","errorDetails":{"csrf":"invalid"},"status":"error"}` {
			cookie = nil
			zond = ""
			CSRFToken()
			return jsonbody
		}
		return jsonbody
	}
	return ""
}
