package user

import (
	"encoding/json"
	"math"
	"skunkyart/util"
	"strconv"
)

func search(user, query *string, page int, output chan string) {
	{
		var tmp struct {
			Total                int
			Results, Pages, Name string
		}

		var q struct {
			EstTotal int
			Results  []util.Deviation
		}

		if *query != "" {
			rawjson := util.Puppy("dashared/gallection/search?username=" + *user + "&q=" + *query + "&offset=" + strconv.Itoa(50*page) + "&type=gallery&order=most-recent&init=true&limit=50")
			err := json.Unmarshal([]byte(rawjson), &q)
			util.Err(err)

			if q.EstTotal != 0 {
				tmp.Total = q.EstTotal
			}

			for _, a := range q.Results {
				tmp.Results += util.Images(a, a.Media, false)
			}

			tmp.Pages = ""
			tmp.Name = *user
			for x := 0; x < int(math.Round(float64(q.EstTotal/50))); x++ {
				tmp.Pages += "<a href=\"/user/" + tmp.Name + "?a=search&p=" + strconv.Itoa(x+1) + "&q=" + *query + "\">" + strconv.Itoa(x+1) + "</a> "
			}

			output <- util.TmpExec("templates/user/search.htm", &tmp)
		} else {
			output <- "Missing query."
		}
	}
}
