package util

type AB struct {
	ErrorDescription string
	Owner            struct {
		Username string
	}
	Gruser struct {
		GruserId int
		Page     struct {
			Modules []struct {
				Name       string
				ModuleData struct {
					About struct {
						Country, Website, WebsiteLabel, Gender, Tagline string
						DeviantFor                                      int64
						SocialLinks                                     []struct {
							Value string
						}
						TextContent Description
						Interests   []struct {
							Label, Value string
						}
					}
					CoverDeviation struct {
						CoverDeviation Deviation
					}

					// группы
					GroupAbout struct {
						Tagline      string
						FoundationTs Time
						Description  struct {
							Html HTML
						}
					}
					GroupAdmins struct {
						Results []struct {
							Username string
						}
					}
					Folders struct {
						Results []struct {
							FolderId int
							Name     string
						}
					}
				}
			}
		}
	}
	PageExtraData struct {
		GruserTagline string
		Stats         struct {
			Deviations, Watchers, Watching, Pageviews, CommentsReceivedProfile, CommentsMade, Favourites, Friends int
		}
	}
}

type Description struct {
	Excerpt string
	Html    struct {
		Markup string
	}
}
